% Doppler V1.1 (May2020)

% Ingreso Matriz desde un archivo de tres columnas i,j,Conteo(i,j)
% (Conteo(i,0) y Conteo(0,j) no contiene conteo de coincidencias)
% C ser el nmero de diagonales (en la matriz de 511x511) "20"

% Para descontar el kapton necesito un vector con el espectro del kapton

Mat=input('matrix name: ');
%C=input('C: ');
C=20;
U=size(Mat);
M=Mat;
N=U(1);

% Inicializo en cero el vector que contendr la "fetta" (ahora el paso ser de 1/2 canal)
for t=1:1021
    V(t)=0;
    Vec(t)=0;
end;

% Cambio el indice j para tener notacin matricial
for p=1:N
    M(p,2)=512-Mat(p,2);
end;

% Se hallan las coordenadas del mximo i1 e i2; d1 y d2 son las
% desviaciones del centro
ma=0;
for p=1:N
    if ((M(p,1) > 0) && (M(p,2) < 512))
        if M(p,3)>=ma
            ma=M(p,3);
            i1=M(p,1);
            i2=M(p,2);
        end
    end
end;
% Desviaciones d1 y d2 respecto del centro de la matriz 
disp('deviation x and y from the center');
d1=256-i1
d2=256-i2

% Vector V1021 contiene la "fetta" (integral en la diagonal principal de
% espesor C) aproximadamente centrado en el canal (511 +/- 1)
% La matriz fue trasladada para tener el maximo en el centro
for p=1:N
  if ((M(p,1) > 0) && (M(p,2) < 512))
    K=(M(p,1)+d1)+(M(p,2)+d2)-1;
    if ((K > 0) && (K < 1021))
      if (((M(p,1)+d1) > 0) && ((M(p,1)+d1) < 512) && ((M(p,2)+d2) > 0) && ((M(p,2)+d2) < 512))
        if ((abs((M(p,1)+d1)-(M(p,2)+d2)) < C))
            V(K)=M(p,3)+V(K);
         elseif (abs((M(p,1)+d1)-(M(p,2)+d2)) == C)
            V(K)=0.5*M(p,3)+V(K);
        end
      end
    end
  end
end;
V1021=V';


% Vector Vec1021 contiene la "fetta" (integral en la diagonal secundaria de
% espesor C) aproximadamente centrado en el canal (511 +/- 1)
% La matriz fue trasladada para tener el maximo en el centro
for p=1:N
  if ((Mat(p,1) > 0) && (Mat(p,2) > 0))
    K=(Mat(p,1)+d1)+(Mat(p,2)-d2)-1;
    if ((K > 0)&&(K < 1021))
      if (((Mat(p,1)+d1) > 0) && ((Mat(p,1)+d1) < 512) && ((Mat(p,2)-d2)) > 0 && ((Mat(p,2)-d2) < 512))
        if (abs((Mat(p,1)+d1)-(Mat(p,2)-d2)) < C)
            Vec(K)=Mat(p,3)+Vec(K);
         elseif (abs((Mat(p,1)+d1)-(Mat(p,2)-d2)) == C)
            Vec(K)=0.5*Mat(p,3)+Vec(K);
        end
      end
    end
  end
end;
Vec1021=Vec';

% saco las primeras 50 y las ultimas 50 filas
y=V1021(51:971);
x=Vec1021(51:971);

% fondo (primeros 50 y ltimos 50)
%f=(sum(y(1:50))+sum(y(872:921)))/100;
%yf=y-f;
%fr=sum(x(872:921))/50;
%xf=x-fr;
xf=x;
yf=y;

%______________________________
% Estima la resolucion ajustando una funcion Gaussiana
% en los puntos cercanos al maximo de la diagonal secundaria
% FWHM resolucion en momento (mrad)
[yyy,k]=max(xf);
extinf=k-10;
extsup=k+20;
VV=xf(extinf:extsup)';
Z=(extinf:extsup);
logp2=polyfit(Z,log(VV),2);
xc=-(logp2(2))/(2*logp2(1));
w=sqrt((-2)/logp2(1));
FWHM=sqrt(log(4))*w*0.02875*(30/4.11);
disp('resolucion en mrad');
disp(FWHM);
disp('resolucion en keV');
disp(FWHM/3.9139);
disp('Area: ');
disp(sum(V));
%______________________________


% centroide
pos=1:921;
cent=sum((pos').*yf)/sum(yf);
r=round(cent);
dif=cent-r;

% Se centra el espectro a un nmero de canal entero (imprecisin de 
% aprox. +/- 1e-10 del canal central, mtodo Spline)
yy=spline(pos',yf,pos'+dif);
yy2=yy(r-450:r+450);
pos=-450:450;
cent=sum((pos').*yy2)/sum(yy2);
yy3=spline(pos',yy2,pos'+cent);
cent=sum((pos').*yy3)/sum(yy3);
MR=spline(pos',yy3,pos'+cent);
% "Cent" indica la precisin del centride con respecto al canal central
cent=sum((pos').*MR)/sum(MR)
% MS contiene el espectro normalizado centrado sin fondo con 361 elementos
% a 1
MS=MR/sum(MR);

% Correccin de la contribucin del Kapton
%Kap=KaptonFitDec04;
Ial=0.125;
Icu=0.15;
Img=0.12;
Izn=0.155;
Iag=0.16;
Izr=0.155;
Ipru=0.12;
Iti=0.14;
Iw=0.175;
Ibeam=0;
% ATENZIONE!!! Cambiare Ic secondo il material in studio
Ic=Ibeam; 
% MSsK contiene el espectro sin Kapton con 361 elementos
%MSsK=(MS-Ic*Kap)/(1-Ic);
% RES ha i dati centrati e normalizzati

%RESULT=(MS-Ic*KaptonSS7)/(1-Ic);
RESULT=(MS-Icu*KaptonSS7)/(1-Icu);

% Borro todos las variables que no necesito
clear C
clear K
clear M
clear MM
clear Mat
clear N
clear U
clear ma
clear V
clear n
clear p
clear t
clear i1
clear i2
clear d1
clear d2
clear V1021
clear y
clear yy
clear yf
clear f
clear pos
clear cent
clear r
clear dif
clear Ial
clear Img
clear Icu
clear Izn
clear Iag
clear Izr
clear Ic
clear MS
clear Kap
clear MR
clear yy2
clear yy3
clear FWHM
clear VV
clear Vec
clear Vec1021
clear Z
clear extinf
clear extsup
clear fr
clear k
clear logp2
clear w
clear x
clear xc
clear xf
clear yyy
clear Iti
clear Ipru
clear Iw
clear Ibeam
