function f=convoluzione(R,u)
% produce in f uno spettro unidimensionale ottenuto come convoluzione di uno spettro u (vettore di m termini) convoluto con una funzione di
% risoluzione strumentale R (vettore di n termini). E' necessario che l'intervallo di scansione di R e u sia lo stesso.

% controlla che n<=m (altrimenti non funziona)ed esegue il calcolo solo in
% caso affermativo
m=length(u);
n=length(R);
if n<=m
    % mette R in forma di matrice quasi-diagonale, con il massimo centrato
    % sulla diagonale principale
    RR=zeros(m,m);
    [picco,p]= max(R);
    for j=1:m
        for k=1:m
            i=p-j+k;
            if i>0 & i<n+1
                RR(j,k)=R(i);
            end
        end
    end
    
    % si assicura che u sia un vettore colonna
    [a,b]=size(u);
    if a<b
        u=u';
    end
    
    %calcola la convoluzione
    ff=RR*u;
    % rinormalizza ff in modo che la convoluzione non alteri la norma dei vettori
    coeff=norm(u)/norm(ff);
    f=coeff*ff;
    
end